#!/bin/bash

yesno() {
    yn_result=""
    while [ -z "$yn_result" ]; do
        read yn_reply
        case "$yn_reply" in
        [Yy]) # y,Y
            yn_result=0 ;;
        [Nn]) # n,N
            yn_result=1 ;;
        *) # other
            echo -n "Please enter y or n:" ;;
        esac
    done
    return $yn_result
}

case "$1" in
"")
    echo
    echo "Usage: $0 xxx@example.com"
    echo
    ;;
*)
    TODAY=$(date +%F)

    LOG_FILE="${TODAY}.log"

    cat /var/log/exim_mainlog | grep $TODAY | grep $1 | grep -v cwd | awk {'print $3'} | uniq | grep -v 'H=' >~/tmp_maillist.txt

    filename=~/tmp_maillist.txt
    index=0
    while read line; do
        VARS[$index]="$line"
        index=$(expr $index + 1)
    done <$filename

    echo '' >${LOG_FILE}

    for ((index = 0; index < ${#VARS[@]}; index++)); do

        echo "===================/信件ID:${VARS[$index]}/==============================" >>${LOG_FILE}
        starttime=$(cat /var/log/exim_mainlog | grep ${VARS[$index]} | head -1 | awk '{print $1 " " $2}')
        endtime=$(cat /var/log/exim_mainlog | grep ${VARS[$index]} | tail -n 1 | awk '{print $1 " " $2}')
        #echo "開始時間: ${starttime}" >>${LOG_FILE}
        #echo "${starttime}" >>${LOG_FILE}
        cat /var/log/exim_mainlog | grep ${VARS[$index]} | sed "s/${VARS[$index]}/\ /g" | awk '{$1=$2="";print}' >>${LOG_FILE}
        sed -i 's/<=/寄件者:/g' ${LOG_FILE}
        sed -i 's/ T=/\n\T=/g' ${LOG_FILE}
        sed -i "s/Completed/結束時間: $endtime/g" ${LOG_FILE}
        #echo "=======================================================================" >>${LOG_FILE}
        echo ' ' >>${LOG_FILE}

    done

    if [[ -z "$2" ]]; then

        sed -i 's/=> |\/usr\/local\/cpanel\/bin\/autorespond/**自動回覆**/g' ${LOG_FILE}
        sed -i 's/ =>/收件者:/g' ${LOG_FILE}
        sed -i 's/T="/主旨="/g' ${LOG_FILE}
        sed -i 's/ for/\n\ for/g' ${LOG_FILE}
        sed -i "/for/d" ${LOG_FILE}
        sed -i "/cwd/d" ${LOG_FILE}
        sed -i 's/as spam/\n\as spam/g' ${LOG_FILE}
        sed -i "/SpamAssassin as mundopro detected message/d" ${LOG_FILE}
        sed -i "/Message has been scanned/d" ${LOG_FILE}
        sed -i 's/as spam/垃圾郵件分數/g' ${LOG_FILE}
        sed -i 's/bypassed/使用者過濾器/g' ${LOG_FILE}
        sed -i "s/P=/\n\P=/g" ${LOG_FILE}
        sed -i "/P=/d" ${LOG_FILE}
        sed -i "/NOT spam/d" ${LOG_FILE}
        sed -i "/no virus or other harmful content was found/d" ${LOG_FILE}
        sed -i "s/id=/\n\ /g" ${LOG_FILE}
        sed -i 's/R=virtual_user/<本機帳號>/g' ${LOG_FILE}
        sed -i "s/R=/\n\R=/g" ${LOG_FILE}
        sed -i 's/CV=yes//g' ${LOG_FILE}
        sed -i 's/CV=no//g' ${LOG_FILE}
        sed -i "s/R=send_to_smart_host//g" ${LOG_FILE}
        sed -i "s/SpamAssassin as faekodivepro6des detected message as spam/這是拉機郵件/g" ${LOG_FILE}
        sed -i "s/No Such User Here/找不到帳號/g" ${LOG_FILE}
        sed -i 's/H=/\n\主機=/g' ${LOG_FILE}
        sed -i 's/\/dev\/null/黑洞/g' ${LOG_FILE}
        sed -i 's/Saved/已保存/g' ${LOG_FILE}
        sed -i 's/queued as /MG碼:/g' ${LOG_FILE}
        sed -i 's/->//g' ${LOG_FILE}
        sed -i 's/T=remote_smtp//g' ${LOG_FILE}
        sed -i '/T=cagefs_virtual_address_pipe/d' ${LOG_FILE}
        sed -i 's/\/home/\n\/home/g' ${LOG_FILE}
        sed -i "/\home/d" ${LOG_FILE}
        sed -i 's/T=dovecot_virtual_delivery//g' ${LOG_FILE}
        sed -i 's/^[     ]*//;s/[     ]*$//' ${LOG_FILE}
        sed -i '/^$/d' ${LOG_FILE}

    else

        sed -i 's/=> |\/usr\/local\/cpanel\/bin\/autorespond/**自動回覆**/g' ${LOG_FILE}
        sed -i 's/ =>/收件者:/g' ${LOG_FILE}
        sed -i 's/T="/主旨="/g' ${LOG_FILE}
        sed -i 's/ for/\n\ for/g' ${LOG_FILE}
        sed -i "/for/d" ${LOG_FILE}
        sed -i "/cwd/d" ${LOG_FILE}
        sed -i 's/ as spam/\n\ as spam/g' ${LOG_FILE}
        sed -i "/SpamAssassin as mundopro detected message/d" ${LOG_FILE}
        sed -i "/Message has been scanned/d" ${LOG_FILE}
        sed -i 's/ as spam/垃圾郵件分數/g' ${LOG_FILE}
        sed -i 's/bypassed/使用者過濾器/g' ${LOG_FILE}
        sed -i "s/P=/\n\P=/g" ${LOG_FILE}
        sed -i "/P=/d" ${LOG_FILE}
        sed -i "/NOT spam/d" ${LOG_FILE}
        sed -i "/no virus or other harmful content was found/d" ${LOG_FILE}
        sed -i "s/id=/\n\ /g" ${LOG_FILE}
        sed -i 's/R=virtual_user/<本機帳號>/g' ${LOG_FILE}
        sed -i "s/R=/\n\R=/g" ${LOG_FILE}
        sed -i 's/CV=yes//g' ${LOG_FILE}
        sed -i 's/CV=no//g' ${LOG_FILE}  
        sed -i "s/R=send_to_smart_host//g" ${LOG_FILE}
        sed -i "s/SpamAssassin as faekodivepro6des detected message as spam/這是拉機郵件/g" ${LOG_FILE}
        sed -i "s/No Such User Here/找不到帳號/g" ${LOG_FILE}
        sed -i 's/H=/\n\主機=/g' ${LOG_FILE}
        sed -i 's/主機=mg1.eee.tw/Gateway: mg1.eee.tw/g' ${LOG_FILE}
        sed -i 's/主機=mg2.eee.tw/Gateway: mg2.eee.tw/g' ${LOG_FILE}
        sed -i 's/主機=mg3.eee.tw/Gateway: mg1.eee.tw/g' ${LOG_FILE}
        sed -i "s/X=/\n\X=/g" ${LOG_FILE}
        sed -i "s/C=/\n\C=/g" ${LOG_FILE}
        sed -i 's/\/dev\/null/黑洞/g' ${LOG_FILE}
        sed -i 's/Saved/\n\Saved/g' ${LOG_FILE}
        sed -i 's/Saved"/已保存/g' ${LOG_FILE}
        sed -i 's/已保存/\n\已保存/g' ${LOG_FILE}
        sed -i 's/queued as /MG碼:/g' ${LOG_FILE}
        sed -i 's/2.0.0 Ok/\n\完成:/g' ${LOG_FILE}
        sed -i 's/->//g' ${LOG_FILE}
        sed -i 's/T=remote_smtp//g' ${LOG_FILE}
        sed -i '/C="250/d' ${LOG_FILE}
        sed -i '/主旨/d' ${LOG_FILE}
        sed -i '/_no_batch/d' ${LOG_FILE}
        sed -i '/主機/d' ${LOG_FILE}
        sed -i '/X=/d' ${LOG_FILE}
        sed -i '/T=cagefs_virtual_address_pipe/d' ${LOG_FILE}
        sed -i 's/\/home/\n\/home/g' ${LOG_FILE}
        sed -i "/\home/d" ${LOG_FILE}
        sed -i 's/T=dovecot_virtual_delivery//g' ${LOG_FILE}
        sed -i 's/^[     ]*//;s/[     ]*$//' ${LOG_FILE}
        sed -i '/^$/d' ${LOG_FILE}

    fi

    rm -f ~/tmp_maillist.txt

    echo "Log file created: ${TODAY}.log"

    #less ${TODAY}.log
    echo -n "Do you want to print the log? (y/n)"

    if yesno; then

        less ${TODAY}.log

        clear

        echo -n "Do you wnat me to delete the log file ${TODAY}.log ?"

        if yesno; then
            /bin/rm -f ${TODAY}.log
            echo "File ${TODAY}.log deleted."
        fi
    fi

    ;;
esac

